#!/usr/bin/env python
#
# $Id: ZctlApp.py,v 1.2 2002/01/01 17:04:09 dhellmann Exp $
#
# Copyright ZapMedia.com.
#

"""Base Class version of zctl.py.
"""

__rcs_info__ = {
    #
    #  Creation Information
    #
    'module_name'  : '$RCSfile: ZctlApp.py,v $',
    'rcs_id'       : '$Id: ZctlApp.py,v 1.2 2002/01/01 17:04:09 dhellmann Exp $',
    'creator'      : ' <Doug.Hellmann@ZapMedia.com>',
    'project'      : 'ZapMedia.com',
    'created'      : 'Wed, 14-Feb-2001 12:37:15 EST',

    #
    #  Current Information
    #
    'author'       : '$Author: dhellmann $',
    'version'      : '$Revision: 1.2 $',
    'date'         : '$Date: 2002/01/01 17:04:09 $',
}

##
## SETUP COPIED and modified FROM ZCTL.PY
##
import sys, os, socket, time, string
from os.path import isfile, isdir, abspath
pjoin = os.path.join
psplit = os.path.split
env = os.environ
run = os.system

# We assume we are running in ZapCentral.
HERE = abspath('.')
# Or allow this to be specified.
if env.has_key('HERE'): HERE = env['HERE']
PYTHON = '"%s"' % sys.executable
ZOPE_ENV = {}
ZEO = {} # ZEO is off by default

# Load configuration data into global variables
ZOPE_CONFIG = pjoin(HERE, 'zope.conf')
if env.has_key('ZOPE_CONFIG'): ZOPE_CONFIG = env['ZOPE_CONFIG']
# Check for the '--conf=<config-file>'
n = 1
while n < len(sys.argv):
    opt = sys.argv[n]
    i = string.find(opt, '--conf=')
    if i > -1:
        ZOPE_CONFIG=opt[len('--conf='):]
        # Remove it so that this doesn't 
    n = n + 1
if not isfile(ZOPE_CONFIG):
    print 'Zope configuration file "zope.conf" not found.'
    sys.exit(1)
# Now make sure HERE is whereever the conf
# file is.
HERE = pjoin(psplit(ZOPE_CONFIG)[:-1])[0]
# Set INSTANCE_HOME
INSTANCE_HOME = env['INSTANCE_HOME'] = HERE
execfile(ZOPE_CONFIG, globals())

# set PYTHONHOME
env['PYTHONHOME'] = ZOPE_HOME = abspath(ZOPE_HOME)

# add ZEO stuff to environment
for k, v in ZEO.items():
    env[k] = str(v)

# Make sure we have everything in our path.
sys.path.insert(0, pjoin(ZOPE_HOME, 'lib', 'python'))
# Not sure why we have to do this...
os.chdir(pjoin(ZOPE_HOME, 'lib', 'python'))
    
class ZctlApp:
    "Base class for zctl applications."

    for k,v in ZOPE_ENV.items():
        env[k] = str(v)
    import Zope
    app = Zope.app()

    def optionHandler_testZEOConnection(self):
        """Print debugging information about the environment
        and test the connectivity to the ZSS.
        """
        print '   PYTHON: ', PYTHON
        print '     HERE: ', HERE
        print 'ZOPE_HOME: ', ZOPE_HOME
        print '      ZEO: ', ZEO
        print ' self.app: ', self.app
        return

    def optionHandler_conf(self, zopeconf):
        """The 'zope.conf' to use."""
        # This function is here in case we are using
        # ZctlApp in conjunction with CommandLineApp just
        # so that the --conf argument is handled.
        pass
