#!/usr/bin/env python
#
# $Id: searchengines_googlegroups.py,v 1.1 2002/03/11 01:55:23 dhellmann Exp $
#
# Copyright 2001 Doug Hellmann.
#
#
#                         All Rights Reserved
#
# Permission to use, copy, modify, and distribute this software and
# its documentation for any purpose and without fee is hereby
# granted, provided that the above copyright notice appear in all
# copies and that both that copyright notice and this permission
# notice appear in supporting documentation, and that the name of Doug
# Hellmann not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission.
#
# DOUG HELLMANN DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
# INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
# NO EVENT SHALL DOUG HELLMANN BE LIABLE FOR ANY SPECIAL, INDIRECT OR
# CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
# OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
# NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
# CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#

"""Search groups.google.com.

"""

__rcs_info__ = {
    #
    #  Creation Information
    #
    'module_name'  : '$RCSfile: searchengines_googlegroups.py,v $',
    'rcs_id'       : '$Id: searchengines_googlegroups.py,v 1.1 2002/03/11 01:55:23 dhellmann Exp $',
    'creator'      : 'Doug Hellmann <DougHellmann@bigfoot.com>',
    'project'      : 'UNSPECIFIED',
    'created'      : 'Sun, 10-Mar-2002 20:40:11 EST',

    #
    #  Current Information
    #
    'author'       : '$Author: dhellmann $',
    'version'      : '$Revision: 1.1 $',
    'date'         : '$Date: 2002/03/11 01:55:23 $',
}

#
# Import system modules
#


#
# Import Local modules
#
from searchengines_google import GoogleSearchPage, GoogleSearchEngine, GoogleSearchResultsList

#
# Module
#

class GoogleGroupsSearchResultsList(GoogleSearchResultsList):

    def addContinuation(self, link):
        url = GoogleGroupsSearchEngine.url_base + link
        self._continuation_links.append(GoogleGroupsSearchPage(url))
        return

class GoogleGroupsSearchPage(GoogleSearchPage):
    def newParser(self):
        return GoogleGroupsSearchResultsList()

class GoogleGroupsSearchEngine(GoogleSearchEngine):
    name = 'GoogleGroups'
    
    url_base = 'http://groups.google.com'
    initial_search_page = '/groups?hl=en&start=0&filter=0&q=%(searchTerms)s'

    search_page_factory = GoogleGroupsSearchPage


def entryPoint():
    return {'name':'GoogleGroups',
            'factory':GoogleGroupsSearchEngine,
            }


